#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <engine>

#include <diablo_nowe.inc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

new iHeal[ 33 ] , bool:bUsedItem[ 33 ] , sprite_white;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	diablo_register_item( "Power Totem" , 250 );
	
	register_think("Effect_Healing_Totem4","Effect_Healing_Totem_Think")
}

public plugin_precache(){
	precache_model( "models/diablomod/totem_heal.mdl" );
	
	sprite_white = precache_model("sprites/white.spr") 
}

public diablo_item_give( id , szRet[] , iLen ){
	formatex( szRet , iLen , "stawiasz totem ,ktry leczy czonkw Twojej druyny %i hp przez 5 sekund.Dziaaniem obejmuje on ca map." , iHeal[ id ] )
}

public diablo_item_reset( id ){
	iHeal[ id ]	=	0;
	bUsedItem[ id ]		=	false;
}

public diablo_item_set_data( id ){
	iHeal[ id ]	=	random_num( 20 , 30 );
	bUsedItem[ id ]		=	false;
}

public diablo_item_player_spawned( id ){
	bUsedItem[ id ]		=	false;
}

public diablo_item_info( id , szMessage[] , iLen , bool:bList ){
	if( bList ){
		formatex( szMessage , iLen , "stawiasz totem ,ktry leczy czonkw Twojej druyny 20-30 hp przez 5 sekund.Dziaaniem obejmuje on ca map.")
	}
	else{
		formatex( szMessage , iLen , "stawiasz totem ,ktry leczy czonkw Twojej druyny %i hp przez 5 sekund.Dziaaniem obejmuje on ca map." , iHeal[ id ] )
	}
}

public diablo_upgrade_item( id ){
	iHeal[ id ] += random_num(0,1)
}

public diablo_copy_item( iFrom , iTo ){
	iHeal[ iTo ]	=	iHeal[ iFrom ];
	
	bUsedItem[ iTo]		=	false;
}

public diablo_item_skill_used( id ){
	if( bUsedItem[ id ] ){
		
		diablo_show_hudmsg( id,2.0,"Leczacy Totem mozesz uzyc raz na runde!" )
		
		return PLUGIN_CONTINUE
	}
	
	bUsedItem[id] = true
	
	new origin[3]
	pev(id,pev_origin,origin)
	
	new ent = Spawn_Ent("info_target")
	set_pev(ent,pev_classname,"Effect_Healing_Totem4")
	set_pev(ent,pev_owner,id)
	set_pev(ent,pev_solid,SOLID_TRIGGER)
	set_pev(ent,pev_origin,origin)
	set_pev(ent,pev_ltime, halflife_time() + 7 + 0.1)
	
	engfunc(EngFunc_SetModel, ent, "models/diablomod/totem_heal.mdl")  	
	set_rendering ( ent, kRenderFxGlowShell, 255,0,0, kRenderFxNone, 255 ) 	
	engfunc(EngFunc_DropToFloor,ent)
	
	set_pev(ent,pev_nextthink, halflife_time() + 0.1)
	
	return PLUGIN_CONTINUE
	
}

stock Spawn_Ent(const classname[]) 
{
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, classname))
	set_pev(ent, pev_origin, {0.0, 0.0, 0.0})    
	dllfunc(DLLFunc_Spawn, ent)
	return ent
}

public Effect_Healing_Totem_Think(ent)
{
	new id = pev(ent,pev_owner)
	new totem_dist = 300
	new amount_healed = iHeal[id]
	
	//We have emitted beam. Apply effect (this is delayed)
	if (pev(ent,pev_euser2) == 1)
	{		
		new Float:forigin[3], origin[3]
		pev(ent,pev_origin,forigin)	
		FVecIVec(forigin,origin)
		
		//Find people near and damage them
		
		for (new i=1; i < 33; i++)
		{					
			if (get_user_team(i) != get_user_team(id))
				continue
			
			if (is_user_alive(i)) diablo_add_hp( i , amount_healed )
		}
		
		set_pev(ent,pev_euser2,0)
		set_pev(ent,pev_nextthink, halflife_time() + 1.5)
		
		return PLUGIN_CONTINUE
	}
	
	//Entity should be destroyed because livetime is over
	if (pev(ent,pev_ltime) < halflife_time() || !is_user_alive(id))
	{
		remove_entity(ent)
		return PLUGIN_CONTINUE
	}
	
	//If this object is almost dead, apply some render to make it fade out
	if (pev(ent,pev_ltime)-2.0 < halflife_time())
	set_rendering ( ent, kRenderFxNone, 255,255,255, kRenderTransAlpha, 100 ) 
	
	new Float:forigin[3], origin[3]
	pev(ent,pev_origin,forigin)	
	FVecIVec(forigin,origin)
	
	//Find people near and give them health
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY, origin );
	write_byte( TE_BEAMCYLINDER );
	write_coord( origin[0] );
	write_coord( origin[1] );
	write_coord( origin[2] );
	write_coord( origin[0] );
	write_coord( origin[1] + totem_dist );
	write_coord( origin[2] + totem_dist );
	write_short( sprite_white );
	write_byte( 0 ); // startframe
	write_byte( 0 ); // framerate
	write_byte( 10 ); // life
	write_byte( 10 ); // width
	write_byte( 255 ); // noise
	write_byte( 255 ); // r, g, b
	write_byte( 100 ); // r, g, b
	write_byte( 100 ); // r, g, b
	write_byte( 128 ); // brightness
	write_byte( 5 ); // speed
	message_end();
	
	set_pev(ent,pev_euser2,1)
	set_pev(ent,pev_nextthink, halflife_time() + 0.5)
	
	
	return PLUGIN_CONTINUE

}