#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <engine>
#include <cstrike>

#include <diablo_nowe.inc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"Unknown"
#define VERSION	"1.0"

#define CSTRIKE_DEFAULT_HE_COST 300

new NADE_PICKUP_SOUND[] = "items/9mmclip1.wav";

new bool:bKlasa[ 33 ] 

new Float:g_GameTime;

new MSG_NO_FUNDS[] = "You have insufficient funds!";
new MSG_CANT_CARRY[] = "You cannot carry anymore!";

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	diablo_register_class( "Piekielny Rycerz" , 125 , "" , FLAG_ALL , "Klasy Unikatowe");
	
	register_menucmd(register_menuid("BuyItem") , (1<<3) , "he_buy");	// Buy HE (old style)
	register_menucmd(-34 , (1<<3) , "he_buy");	// Buy HE (VGUI)
	register_clcmd("hegren" , "he_buy");		// Buy HE (Steam)
	
	register_event("HLTV" , "new_round" , "a" , "1=0" , "2=0");
	
	register_message(get_user_msgid("TextMsg") , "block_message");
	
	register_touch("armoury_entity" , "player" , "touch_player");
}

public new_round() {
	g_GameTime = get_gametime();
}

public plugin_precache()
	precache_sound(NADE_PICKUP_SOUND);

public he_buy(id){
	if(bKlasa[ id ]){ 
		handle_buy(id , CSW_HEGRENADE);
	}
}

public handle_buy(id , nade) 
{
	if(!is_user_alive(id) || get_user_team(id) > 2)
		return PLUGIN_CONTINUE;

	new ammo = cs_get_user_bpammo(id , nade);

	if(!ammo) /* If the player doesn't have a nade yet, let CS handle it */
		return PLUGIN_CONTINUE;

	if(!cs_get_user_buyzone(id)) /* Check if the player is in the buyzone */
		return PLUGIN_CONTINUE;

	new max_ammo , cost;

	switch(nade) 
	{
		case CSW_HEGRENADE:	max_ammo = 2	  , cost = CSTRIKE_DEFAULT_HE_COST;
	}

	new Float:buytime = get_cvar_float("mp_buytime") * 60.0;
	new Float:timepassed = get_gametime() - g_GameTime;

	if(floatcmp(timepassed , buytime) == 1)
		return PLUGIN_HANDLED;

	if(cs_get_user_money(id) - cost <= 0) 
	{
		client_print(id , print_center , MSG_NO_FUNDS);
		return PLUGIN_HANDLED;
	}

	if(ammo == max_ammo) 
	{
		client_print(id , print_center , MSG_CANT_CARRY);
		return PLUGIN_HANDLED;
	}

	give_nade(id , nade);

	cs_set_user_money(id , cs_get_user_money(id) - cost , 1);

	return PLUGIN_CONTINUE;
}

public touch_player(pToucher , pTouched) 
{
	if(!is_valid_ent(pToucher) || !is_user_alive(pTouched) || !bKlasa[ pTouched ])
		return PLUGIN_CONTINUE;

	if(entity_get_int(pToucher , EV_INT_iuser1))
		return PLUGIN_HANDLED;

	new pToucherMdl[64];
	entity_get_string(pToucher , EV_SZ_model , pToucherMdl , 63);

	new model = check_nade_model(pToucherMdl); /* Check if the model is a grenade's */

	if(model != -1) /* If it's a grenade it'll return a value > -1 */
	{
		new ammo = cs_get_user_bpammo(pTouched , model) , max_ammo;

		switch(model) /* Get the max values for grenade ammo types */
		{
			case CSW_HEGRENADE:	max_ammo = 2;
		}

		if(max_ammo <= 0) /* If the max ammo cvar doesn't have a value > 0 then hault the code */
			return PLUGIN_CONTINUE;

		if(ammo <= 0) /* Let CS handle the first grenade */
		{ 
			set_entity_visibility(pToucher , 0);
			entity_set_int(pToucher , EV_INT_iuser1 , 1);

			return PLUGIN_CONTINUE;
		}

		if(ammo > 0 && ammo < max_ammo) /* Everything is OK so give the grenade! */
		{
			set_entity_visibility(pToucher , 0);
			entity_set_int(pToucher , EV_INT_iuser1 , 1);
			give_nade(pTouched , model);

			return PLUGIN_HANDLED;
		}
	}

	return PLUGIN_CONTINUE;
}

public diablo_damage_class_do(iVictim,iAttacker,&Float:fDamage,damageBits){
	if( damageBits & _:diabloDamageGrenade && !task_exists( iVictim ) && get_user_team( iVictim ) != get_user_team( iAttacker ) ){
		diablo_display_icon( iVictim , 1 , "dmg_heat" , 255 , 0 , 0 );
		
		new Data[2];
		
		Data[0]	=	iAttacker;
		Data[1]	=	iVictim;
		
		remove_task( iVictim );
		remove_task( iVictim + 666 );
		
		set_task( 4.0 , "createDamage" , iVictim , Data , 2 , "a" , 4 )
		set_task( 16.0 , "hideIcon" , iVictim + 666 );
	}
}

public hideIcon( id ){
	id -= 666;
	
	if( is_user_connected( id ) ){
		diablo_display_icon( id , 0 , "dmg_heat" , 255 , 0 , 0 );
	}
	
	remove_task( id );
}

public createDamage( Data[] ){
	if( is_user_alive( Data[1] ) ){
		diablo_damage( Data[1] , Data[0] , 10.0 , diabloDamageKnife );
	}
	else{
		remove_task( Data[1]);
	}
}

public diablo_player_spawned( id ){
	remove_task( id );
}

public check_nade_model(model[]) 
{
	if(equal(model, "models/w_flashbang.mdl" )) 
		return CSW_FLASHBANG;
	if(equal(model, "models/w_hegrenade.mdl")) 
		return CSW_HEGRENADE;
	if(equal(model, "models/w_smokegrenade.mdl")) 
		return CSW_SMOKEGRENADE;

	return -1;
}

public give_nade(id , grenade) 
{
	new ammo = cs_get_user_bpammo(id , grenade);
	cs_set_user_bpammo(id , grenade , ammo + 1);

	emit_sound(id, CHAN_WEAPON , NADE_PICKUP_SOUND , 1.0 , ATTN_NORM , 0 , PITCH_NORM);
}

public block_message(Msgtype, iMsgid, id) /* Blocks the "You cannot carry anymore" message" */
{
	if(get_msg_argtype(2) == ARG_STRING && bKlasa[ id ]) 
	{
		new value[64];
		get_msg_arg_string(2 , value , 63);

		if(equali(value , "#Cannot_Carry_Anymore"))
			return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}

public diablo_class_enabled( id ){
	bKlasa[ id ]	=	true;
}

public diablo_class_disabled( id ){
	bKlasa[ id ]	=	false;
}

public diablo_death(iKiller , killerClass , iVictim , victimClass ){
	if( is_user_alive( iKiller ) && bKlasa [ iKiller ]){
		set_task( 2.0 , "giveGrenade" , iKiller + 120 );
	}
}

public giveGrenade( iKiller ){
	iKiller	-=	120;
	
	if( is_user_alive( iKiller ) && bKlasa [ iKiller ]){
		give_item( iKiller , "weapon_hegrenade" );
	}
}

public Float:diablo_cast_time( id , Float:standardTime ){
	return standardTime;
}

public diablo_call_cast( id ){
	if( get_user_health( id ) >= 100 ){
		return PLUGIN_CONTINUE;
	}
	if( get_user_health( id ) + 7 <= 100 ){ 
		diablo_add_hp( id , 7 );
	}
	else{
		diablo_add_hp( id , 100 - get_user_health( id ) );
	}
	
	return PLUGIN_CONTINUE;
}